structure Tokens = Tokens
structure Interface = Interface
open Interface

type pos = Interface.pos
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult = (svalue,pos) token

fun eof() = Tokens.EOF(!line,!line)
fun makeInt (s : string) = s

%%  
%header (functor NL_LexFun(structure Tokens: NL__TOKENS
                           structure Interface: INTERFACE) : LEXER);
%full 

idchars=[0-9]|[_&+/@|#*`'><];   
alpha=[a-zA-Z];
comment=%(.*)\n;
whitespace=[\t\ ]*;
%%
<INITIAL>{whitespace} => (lex());
<INITIAL>{comment}    => (next_line(); lex());
<INITIAL>\n           => (next_line(); lex());
<INITIAL>"Der"        => (Tokens.DET(!line,!line));
<INITIAL>"Die"        => (Tokens.DET(!line,!line));
<INITIAL>"Jede"       => (Tokens.JEDER(!line,!line));
<INITIAL>"Jeder"      => (Tokens.JEDER(!line,!line));
<INITIAL>"Eine"       => (Tokens.EIN(!line,!line));
<INITIAL>"Ein"        => (Tokens.EIN(!line,!line));
"."        => (Tokens.PUNKT(!line,!line));
"und"      => (Tokens.UND(!line,!line));
"oder"     => (Tokens.ODER(!line,!line));
"nicht"    => (Tokens.NICHT(!line,!line));
"der"      => (Tokens.DET(!line,!line));
"die"      => (Tokens.DET(!line,!line));
"ist"      => (Tokens.IST(!line,!line));
"Anna"     => (Tokens.pn(D.Anna,!line,!line));
"Emil"     => (Tokens.pn(D.Emil,!line,!line));
"Maria"    => (Tokens.pn(D.Maria,!line,!line));
"Mann"     => (Tokens.n(D.Mann,!line,!line));
"Frau"     => (Tokens.n(D.Frau,!line,!line));
"Student"  => (Tokens.n(D.Student,!line,!line));
"arbeitet" => (Tokens.iv(D.arbeitet,!line,!line));
"kennt"    => (Tokens.tv(D.kennt,!line,!line));
"liebt"    => (Tokens.tv(D.liebt,!line,!line));
"jede"     => (Tokens.JEDER(!line,!line));
"jeder"    => (Tokens.JEDER(!line,!line));
"eine"     => (Tokens.EIN(!line,!line));
"ein"      => (Tokens.EIN(!line,!line));
.          => (error ("ignoring illegal character " ^ yytext,
                      !line,!line); lex());

